var roleHarvester = require('role.harvester');
var roleUpgrader = require('role.upgrader');
var roleBuilder = require('role.builder');
var roleRepairer = require('role.repairer');

const roleMap = {
    harvester: roleHarvester,
    upgrader: roleUpgrader,
    builder: roleBuilder,
    repairer: roleRepairer
};

function runRole(creep){
	const role = roleMap[creep.memory.role];

	if(role && typeof role.run === 'function'){
		role.run(creep);
	} else {
		console.log('Unknown or underfied role: ' + creep.memory.role);
	}
}

module.exports = { runRole };
